/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * The model environment, commandline,  methods to
 * construct and render model
 *
 */
public class CommandLinePig {


    public static void main(String[] args) {
         // Use this as an test area when starting out
        // I.e. instantiate objects and test
        // Later just comment out (don't erase the test code!)



        // Uncomment this when you have a model
        //new CommandLineLCR().run();

        new CommandLinePig().run();  // Create the command line object
    }

    private void run() {
        boolean done = false;
        Pig pig = buildPig();   // Always a method to construct the model
        System.out.println("Pig started");
        render(pig);            // Always a method to render the model
        Scanner s = new Scanner(System.in);

        while (!done) {
            System.out.print("> ");
            String cmd = s.nextLine();
            switch (cmd) {
                case "r":
                    int result = pig.roll();
                    System.out.println("Got " + result);
                    if (result == 1) {
                        pig.next(); // No need to add total
                        render(pig);
                    }
                    break;
                case "n":
                    pig.setTotal();
                    if (pig.gameOver()) {
                        done = true;
                    } else {
                        pig.next();
                        render(pig);
                    }
                    break;
                case "q":
                    done = true;
                    break;
                default:
                    System.out.println("?");
            }
        }

        if (pig.gameOver()) {
            System.out.println("Game over! Winner is " + pig.getActualPlayer());
        } else {
            render(pig);
            System.out.println("Game aborted");
        }

    }

    private Pig buildPig() {  // Construct model
        PigDice dice = new PigDice(6);
        List<Player> players = new ArrayList<>();
        players.add(new Player("Anna", dice));
        players.add(new Player("Urban", dice));
        players.add(new Player("Fia", dice));
        return new Pig(players, dice, 20);
    }

    private void render(Pig pig) { // Render model
        for (Player p : pig.getPlayers()) {
            System.out.print(p + " ");
        }
        System.out.println();
        System.out.println("Player is " + pig.getActualPlayer().getName());
    }
}

//--------------------------------------------------------------------
     /* TODO
        if ( ... ) {
            System.out.println("Game over! Winner is " + lcr.getWinner());
        } else {
            render(lcr);
            System.out.println("Game aborted");
        }*/


    /*  TODO
    private ... buildLCRGame() {
        //return ...
    }
    */

    /* TODO
    private void render( ... ) {
        // This needs overridden toString method to work!
        for (String s : lcr.getResult()) {
            System.out.print(s + "  ");
        }
        System.out.println();
        for (Player p : lcr.getPlayers()) {
            System.out.print(p + " ");
        }
        System.out.println();
    }*/

